import { S as Simplify } from './simplify-BVYdScmB.js';

type OmitIndexSignature<ObjectType> = {
    [KeyType in keyof ObjectType as {} extends Record<KeyType, unknown> ? never : KeyType]: ObjectType[KeyType];
};

type PickIndexSignature<ObjectType> = {
    [KeyType in keyof ObjectType as {} extends Record<KeyType, unknown> ? KeyType : never]: ObjectType[KeyType];
};

type SimpleMerge<Destination, Source> = Source & {
    [Key in keyof Destination as Key extends keyof Source ? never : Key]: Destination[Key];
};
type Merge<Destination, Source> = Simplify<SimpleMerge<OmitIndexSignature<Destination>, OmitIndexSignature<Source>> & SimpleMerge<PickIndexSignature<Destination>, PickIndexSignature<Source>>>;

export type { Merge as M, OmitIndexSignature as O, PickIndexSignature as P };
